# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`zot`](#zot): Main class, includes all other classes

#### Private Classes

* `zot::config`: This class handles the zot configuration file.
* `zot::install`: This class handles zot packages.
* `zot::service`: This class handles the zot service

### Functions

* [`zot::to_yaml`](#zot--to_yaml): https://github.com/puppetlabs/puppet-specifications/blob/master/language/func-api.md#the-4x-api

## Classes

### <a name="zot"></a>`zot`

Main class, includes all other classes

#### Examples

##### 

```puppet
include zot
```

#### Parameters

The following parameters are available in the `zot` class:

* [`archive_download_arch`](#-zot--archive_download_arch)
* [`archive_download_base`](#-zot--archive_download_base)
* [`archive_download_os`](#-zot--archive_download_os)
* [`archive_download_url`](#-zot--archive_download_url)
* [`archive_download_version`](#-zot--archive_download_version)
* [`binary_path`](#-zot--binary_path)
* [`config_dir`](#-zot--config_dir)
* [`config_dist_spec_version`](#-zot--config_dist_spec_version)
* [`config_epp_parameters`](#-zot--config_epp_parameters)
* [`config_epp_template`](#-zot--config_epp_template)
* [`config_file`](#-zot--config_file)
* [`config_hash`](#-zot--config_hash)
* [`config_http`](#-zot--config_http)
* [`data_dir`](#-zot--data_dir)
* [`config_log`](#-zot--config_log)
* [`config_extensions_lint`](#-zot--config_extensions_lint)
* [`config_extensions_metrics`](#-zot--config_extensions_metrics)
* [`config_extensions_scrub`](#-zot--config_extensions_scrub)
* [`config_extensions_search`](#-zot--config_extensions_search)
* [`config_extensions_sync`](#-zot--config_extensions_sync)
* [`config_storage`](#-zot--config_storage)
* [`gid`](#-zot--gid)
* [`group`](#-zot--group)
* [`install_method`](#-zot--install_method)
* [`log_dir`](#-zot--log_dir)
* [`manage_config_dir`](#-zot--manage_config_dir)
* [`manage_data_dir`](#-zot--manage_data_dir)
* [`manage_group`](#-zot--manage_group)
* [`manage_log_dir`](#-zot--manage_log_dir)
* [`manage_service_file`](#-zot--manage_service_file)
* [`manage_service`](#-zot--manage_service)
* [`manage_sync_credentials_file`](#-zot--manage_sync_credentials_file)
* [`manage_user`](#-zot--manage_user)
* [`package_ensure`](#-zot--package_ensure)
* [`package_name`](#-zot--package_name)
* [`service_enable`](#-zot--service_enable)
* [`service_ensure`](#-zot--service_ensure)
* [`service_epp_parameters`](#-zot--service_epp_parameters)
* [`service_epp_template`](#-zot--service_epp_template)
* [`service_name`](#-zot--service_name)
* [`sync_credentials_file`](#-zot--sync_credentials_file)
* [`sync_credentials`](#-zot--sync_credentials)
* [`uid`](#-zot--uid)
* [`user`](#-zot--user)

##### <a name="-zot--archive_download_arch"></a>`archive_download_arch`

Data type: `String`

Archictecture for the binary archive

##### <a name="-zot--archive_download_base"></a>`archive_download_base`

Data type: `Stdlib::HTTPUrl`

Base url for the binary archive

##### <a name="-zot--archive_download_os"></a>`archive_download_os`

Data type: `String`

OS for the binary archive

##### <a name="-zot--archive_download_url"></a>`archive_download_url`

Data type: `Optional[Stdlib::HTTPUrl]`

Optional alternative url for downloading the archive

##### <a name="-zot--archive_download_version"></a>`archive_download_version`

Data type: `String`

Verison for the binary archive

##### <a name="-zot--binary_path"></a>`binary_path`

Data type: `Stdlib::Unixpath`

Path where the binary should be/is installed

##### <a name="-zot--config_dir"></a>`config_dir`

Data type: `Stdlib::Unixpath`

Directory to place the configuration files

##### <a name="-zot--config_dist_spec_version"></a>`config_dist_spec_version`

Data type: `String`

Dist spec version set in the configuration file

##### <a name="-zot--config_epp_parameters"></a>`config_epp_parameters`

Data type: `Hash`

Hash with parameters to hash to the custom epp file

##### <a name="-zot--config_epp_template"></a>`config_epp_template`

Data type: `Optional[String]`

Optional epp template for the configuration file

##### <a name="-zot--config_file"></a>`config_file`

Data type: `Stdlib::Unixpath`

Full path to place the configuration file

##### <a name="-zot--config_hash"></a>`config_hash`

Data type: `Optional[Hash]`

Optional config hash that will be converted to yaml for the config file

##### <a name="-zot--config_http"></a>`config_http`

Data type: `Hash`

Hash containing the http section in the config file

##### <a name="-zot--data_dir"></a>`data_dir`

Data type: `Stdlib::Unixpath`

Directory where to store the zot data

##### <a name="-zot--config_log"></a>`config_log`

Data type: `Hash`

Hash containing the log section in the config file

##### <a name="-zot--config_extensions_lint"></a>`config_extensions_lint`

Data type: `Optional[Hash]`

Hash containing the lint extension configuration in the config file

##### <a name="-zot--config_extensions_metrics"></a>`config_extensions_metrics`

Data type: `Optional[Hash]`

Hash containing the metrics extension configuration in the config file

##### <a name="-zot--config_extensions_scrub"></a>`config_extensions_scrub`

Data type: `Optional[Hash]`

Hash containing the scrub extension configuration in the config file

##### <a name="-zot--config_extensions_search"></a>`config_extensions_search`

Data type: `Optional[Hash]`

Hash containing the search extension configuration in the config file

##### <a name="-zot--config_extensions_sync"></a>`config_extensions_sync`

Data type: `Optional[Hash]`

Hash containing the sync extension configuration in the config file

##### <a name="-zot--config_storage"></a>`config_storage`

Data type: `Hash`

Hash containing the storage section in the config file

##### <a name="-zot--gid"></a>`gid`

Data type: `Accounts::User::Uid`

GID of the zot group

##### <a name="-zot--group"></a>`group`

Data type: `String`

Name of the zot group

##### <a name="-zot--install_method"></a>`install_method`

Data type: `Enum['url', 'package', 'none']`

Method to install zot
Possible values: url, package or none

##### <a name="-zot--log_dir"></a>`log_dir`

Data type: `Stdlib::Unixpath`

Directory to store the zot logs

##### <a name="-zot--manage_config_dir"></a>`manage_config_dir`

Data type: `Boolean`

Whether to manage the zot config_dir

##### <a name="-zot--manage_data_dir"></a>`manage_data_dir`

Data type: `Boolean`

Whether to manage the zot data_dir

##### <a name="-zot--manage_group"></a>`manage_group`

Data type: `Boolean`

Whether to manage the zot group

##### <a name="-zot--manage_log_dir"></a>`manage_log_dir`

Data type: `Boolean`

Whether to manage the zot log dir

##### <a name="-zot--manage_service_file"></a>`manage_service_file`

Data type: `Boolean`

Whether to manage the zot systemd service file

##### <a name="-zot--manage_service"></a>`manage_service`

Data type: `Boolean`

Whether to manage the zot service

##### <a name="-zot--manage_sync_credentials_file"></a>`manage_sync_credentials_file`

Data type: `Boolean`

Whether to manage the sync credentials file

##### <a name="-zot--manage_user"></a>`manage_user`

Data type: `Boolean`

Whether to manage the zot user

##### <a name="-zot--package_ensure"></a>`package_ensure`

Data type: `String`

Ensure parameter of the zot package resource

##### <a name="-zot--package_name"></a>`package_name`

Data type: `String`

Name of the zot package resource

##### <a name="-zot--service_enable"></a>`service_enable`

Data type: `Boolean`

Determines if the service should be enabled

##### <a name="-zot--service_ensure"></a>`service_ensure`

Data type: `String`

Ensure parameter of the zot service resource

##### <a name="-zot--service_epp_parameters"></a>`service_epp_parameters`

Data type: `Hash`

Hash with parameters to hash to the custom epp file

##### <a name="-zot--service_epp_template"></a>`service_epp_template`

Data type: `Optional[String]`

Optional epp template for the zot systemd service file

##### <a name="-zot--service_name"></a>`service_name`

Data type: `String`

Name of the zot service

##### <a name="-zot--sync_credentials_file"></a>`sync_credentials_file`

Data type: `Stdlib::Unixpath`

Path to store the sync credentials file

##### <a name="-zot--sync_credentials"></a>`sync_credentials`

Data type: `Hash`

Content of the sync credentials file

##### <a name="-zot--uid"></a>`uid`

Data type: `Accounts::User::Uid`

UID of the zot user

##### <a name="-zot--user"></a>`user`

Data type: `String`

Name of the zot user

## Functions

### <a name="zot--to_yaml"></a>`zot::to_yaml`

Type: Ruby 4.x API

https://github.com/puppetlabs/puppet-specifications/blob/master/language/func-api.md#the-4x-api

#### `zot::to_yaml(Any $data, Optional[Integer] $depth, Optional[Hash] $options)`

https://github.com/puppetlabs/puppet-specifications/blob/master/language/func-api.md#the-4x-api

Returns: `Any` Returns a String with the structured data in YAML format.

##### `data`

Data type: `Any`

The data that should be transformed to YAML.

##### `depth`

Data type: `Optional[Integer]`

Optional. An Integer which described the number of space characters used to indent.

##### `options`

Data type: `Optional[Hash]`

Optional. Pass a Hash of additional options. Refer to Ruby's psych library.

